HDU - 1087 - Super Jumping! Jumping! Jumping!(dp & 寻找价值最大的子串)

HDU - 1087 - Super Jumping! Jumping! Jumping!

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.

The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
Output
For each case, print the maximum according to rules, and one line one case.
Sample Input
3 1 3 2
4 1 2 3 4
4 3 3 2 1
0
Sample Output
4
10
3

题目是多组测试数据输入,第一个数字是n,棋子的数量,后面是经过该棋子的价值,每一次跳一个棋子,也可以跳过多个棋子,增加的价值是最后落在的棋子的价值,并且要求经过的棋子价值严格的单调递增。

其实说白了就是求一个不必要连续的价值和最大的递增子字符串。这样的话,用dp[i]数组代表到达 i 棋子的时候能够获得的最大价值,从dp[1]开始往后遍历每一个棋子就可以了。每一个棋子都往前遍历(因为不一定是连续的,所以判断的时候不可以只判断该棋子前面一个),只要前面棋子比当前棋子价值小,就看一下是否能与该子串构成最大价值的子串。
AC代码:

#include <cstdio>
#include <algorithm>
#include <cstring>
#define ll long long
using namespace std;
const int maxn = 1e3 + 5;
int a[maxn];
ll dp[maxn];

int main()
{
    int n;
    while(~scanf("%d", &n), n)
    {
        memset(dp, 0, sizeof(dp));
        for(int i = 1; i <= n; i++) scanf("%d", &a[i]);
        for(int i = 1; i <= n; i++)
        {
            dp[i] = a[i];
            for(int j = 1; j < i; j++)
                if(a[i] > a[j] && dp[j] + a[i] > dp[i]) dp[i] = dp[j] + a[i];
        }
        sort(dp + 1, dp + 1 + n);
        printf("%lld\n", dp[n]);
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/weixin_40788897/article/details/81742886